<?php
/**
 * @package	Hikashop Action log Plugin
 * @version	1.1.0
 * @author	HikaShop
 * @copyright	(C) 2010-2024 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

defined('_JEXEC') or die;

if (version_compare(JVERSION, '4.0', 'lt'))
{
	return;
}	

use Joomla\Component\Actionlogs\Administrator\Plugin\ActionLogPlugin;

class PlgActionlogHikashop extends ActionLogPlugin
{
	public $element = '';
	public $email_log_id = '';
	public $email = '';
	public $data = array();

	public function onAfterProductCreate(&$element) {
		$type = 'product';
		if(!empty($element->product_type) && !in_array($element->product_type, array('main', 'trash', 'waiting_approval'))) {
			$type = $element->product_type;
		}
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			$type,
			'add',
			$element->product_id,
			$element->product_name,
			'index.php?option=com_hikashop&ctrl=product&task=edit&product_id='.$element->product_id,
		);
	}
	public function onAfterProductUpdate(&$element) {
		$type = 'product';
		if(!empty($element->product_type) && !in_array($element->product_type, array('main', 'trash', 'waiting_approval'))) {
			$type = $element->product_type;
		}elseif(!empty($element->old->product_type) && !in_array($element->old->product_type, array('main', 'trash', 'waiting_approval'))) {
			$type = $element->old->product_type;
		}
		$name = '';
		if(!empty($element->product_name)) {
			$name = $element->product_name;
		} elseif(!empty($element->old->product_name)) {
			$name = $element->old->product_name;
		}
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			$type,
			'update',
			$element->product_id,
			$name,
			'index.php?option=com_hikashop&ctrl=product&task=edit&product_id='.$element->product_id,
		);
	}
	public function onAfterProductCopy(&$src, &$dst) {
		$type = 'product';
		if(!empty($dst->product_type) && !in_array($dst->product_type, array('main', 'trash', 'waiting_approval'))) {
			$type = $dst->product_type;
		}
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			$type,
			'copy',
			$dst->product_id,
			$dst->product_name,
			'index.php?option=com_hikashop&ctrl=product&task=edit&product_id='.$dst->product_id,
		);
	}

	public function onAfterProductsImport(&$importHelper, &$importProducts) {
		static $already = array();
		foreach($importProducts as $element) {
			if(!isset($element->product_id) || isset($already[$element->product_id]))
				continue;
			$already[$element->product_id] = true;
			$type = 'product';
			if(!empty($element->product_type) && !in_array($element->product_type, array('main', 'trash', 'waiting_approval'))) {
				$type = $element->product_type;
			}
			$this->addHikashopLog(
				'PLG_ACTIONLOG_HIKASHOP_PRODUCTS_IMPORTED',
				$type,
				'import',
				$element->product_id,
				$element->product_name,
				'index.php?option=com_hikashop&ctrl=product&task=edit&product_id='.$element->product_id,
			);
		}
	}

	public function onBeforeProductExport(&$products, &$categories, &$productView) {
		$this->addHikashopLog(
			'PLG_ACTIONLOG_HIKASHOP_PRODUCTS_EXPORTED',
			'product',
			'export',
			0,
			'HIKASHOP_TYPE_PRODUCT',
			'',
		);
	}

	public function onBeforeProductDelete(&$elements, &$do) {
		$productClass = hikashop_get('class.product');
		if(!isset($this->data['product']))
			$this->data['product'] = array();
		if(!isset($this->data['product']['delete']))
			$this->data['product']['delete'] = array();
		foreach($elements as $element) {
			$this->data['product']['delete'][$element] = $productClass->get($element);
		}
	}
	public function onAfterProductDelete(&$elements) {
		foreach($elements as $element) {
			$type = 'product';
			if(!empty($this->data['product']['delete'][$element]) && !empty($this->data['product']['delete'][$element]->product_type)) {
				if(!in_array($this->data['product']['delete'][$element]->product_type, array('main', 'trash', 'waiting_approval')))
					$type = $this->data['product']['delete'][$element]->product_type;
			}
			$name = 'product with id '.$element;
			if(!empty($this->data['product']['delete'][$element]) && !empty($this->data['product']['delete'][$element]->product_name)) {
				$name = $this->data['product']['delete'][$element]->product_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				$type,
				'delete',
				0,
				$name,
			);
		}
	}
	public function onAfterCategoryCreate(&$element) {
		$type = 'category';
		if(!empty($element->category_type) && in_array($element->category_type, array('manufacturer', 'tax'))) {
			$type = $element->category_type;
			if($type == 'tax')
				$type = 'tax_category';
		}
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			$type,
			'add',
			$element->category_id,
			$element->category_name,
			'index.php?option=com_hikashop&ctrl=category&task=edit&category_id='.$element->category_id,
		);
	}
	public function onAfterCategoryUpdate(&$element) {
		$category_type = null;
		if(!empty($element->category_type))
			$category_type = $element->category_type;
		elseif(!empty($element->old->category_type))
			$category_type = $element->old->category_type;
		$type = 'category';
		if(!empty($category_type) && in_array($category_type, array('manufacturer', 'tax'))) {
			$type = $category_type;
			if($type == 'tax')
				$type = 'tax_category';
		}
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			$type,
			'update',
			$element->category_id,
			$element->category_name,
			'index.php?option=com_hikashop&ctrl=category&task=edit&category_id='.$element->category_id,
		);
	}

	public function onBeforeCategoryDelete(&$elements, &$do) {
		$categoryClass = hikashop_get('class.category');
		if(!isset($this->data['category']))
			$this->data['category'] = array();
		if(!isset($this->data['category']['delete']))
			$this->data['category']['delete'] = array();
		foreach($elements as $element) {
			$this->data['category']['delete'][$element] = $categoryClass->get($element, false, false);
		}
	}

	public function onAfterCategoryDelete(&$elements) {
		foreach($elements as $element) {
			$type = 'category';
			if(!empty($this->data['category']['delete'][$element]) && !empty($this->data['category']['delete'][$element]->category_type)) {
				$type = $this->data['category']['delete'][$element]->category_type;
				if($type == 'tax')
					$type = 'tax_category';
			}
			$name = 'category with id '.$element;
			if(!empty($this->data['category']['delete'][$element]) && !empty($this->data['category']['delete'][$element]->category_name)) {
				$name = $this->data['category']['delete'][$element]->category_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				$type,
				'delete',
				0,
				$name,
			);
		}
	}

	public function onAfterOrderCreate(&$element) {
		$type = 'order';
		if(!empty($element->order_type) && !in_array($element->order_type, array('sale'))) {
			$type = $element->order_type;
		}
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			$type,
			'add',
			$element->order_id,
			$element->order_number,
			'index.php?option=com_hikashop&ctrl=order&task=edit&order_id='.$element->order_id,
		);
	}
	public function onAfterOrderUpdate(&$element) {
		$type = 'order';
		if(!empty($element->order_type) && !in_array($element->order_type, array('sale'))) {
			$type = $element->order_type;
		}
		if(!empty($element->old->order_type) && !in_array($element->old->order_type, array('sale'))) {
			$type = $element->old->order_type;
		}
		$order_number = '';
		if(!empty($element->order_number)) {
			$order_number = $element->order_number;
		} elseif(!empty($element->old->order_number)) {
			$order_number = $element->old->order_number;
		}
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			$type,
			'update',
			$element->order_id,
			$order_number,
			'index.php?option=com_hikashop&ctrl=order&task=edit&order_id='.$element->order_id,
		);
	}
	public function onBeforeOrderDelete(&$elements, &$do) {
		$orderClass = hikashop_get('class.order');
		if(!isset($this->data['order']))
			$this->data['order'] = array();
		if(!isset($this->data['order']['delete']))
			$this->data['order']['delete'] = array();
		foreach($elements as $element) {
			$this->data['order']['delete'][$element] = $orderClass->get($element);
		}
	}
	public function onAfterOrderDelete(&$elements) {
		foreach($elements as $element) {
			$type = 'order';
			if(!empty($this->data['order']['delete'][$element]) && !empty($this->data['order']['delete'][$element]->order_type)) {
				if(!in_array($this->data['order']['delete'][$element]->order_type, array('sale')))
					$type = $this->data['order']['delete'][$element]->order_type;
			}
			$name = 'order with id '.$element;
			if(!empty($this->data['order']['delete'][$element]) && !empty($this->data['order']['delete'][$element]->order_number)) {
				$name = $this->data['order']['delete'][$element]->order_number;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				$type,
				'delete',
				0,
				$name,
			);
		}
	}

	public function onBeforeOrderExport(&$rows, &$obj) {
		$this->addHikashopLog(
			'PLG_ACTIONLOG_HIKASHOP_ORDERS_EXPORTED',
			'order',
			'export',
			0,
			'HIKASHOP_TYPE_ORDER',
			'',
		);
	}
	public function onAfterOrderstatusCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'orderstatus',
			'add',
			$element->orderstatus_id,
			$element->orderstatus_name,
			'index.php?option=com_hikashop&ctrl=orderstatus&task=edit&cid='.$element->orderstatus_id,
		);
	}
	public function onAfterOrderstatusUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'orderstatus',
			'update',
			$element->orderstatus_id,
			$element->orderstatus_name,
			'index.php?option=com_hikashop&ctrl=orderstatus&task=edit&cid='.$element->orderstatus_id,
		);
	}

	public function onBeforeOrderstatusDelete(&$elements, &$do) {
		$orderClass = hikashop_get('class.orderstatus');
		if(!isset($this->data['orderstatus']))
			$this->data['orderstatus'] = array();
		if(!isset($this->data['orderstatus']['delete']))
			$this->data['orderstatus']['delete'] = array();
		foreach($elements as $element) {
			$this->data['orderstatus']['delete'][$element] = $orderClass->get($element);
		}
	}
	public function onAfterOrderstatusDelete(&$elements) {
		foreach($elements as $element) {

			$name = 'order status with id '.$element;
			if(!empty($this->data['orderstatus']['delete'][$element]) && !empty($this->data['orderstatus']['delete'][$element]->orderstatus_name)) {
				$name = $this->data['orderstatus']['delete'][$element]->orderstatus_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'orderstatus',
				'delete',
				0,
				$name,
			);
		}
	}

	public function onAfterUserCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'user',
			'add',
			$element->user_id,
			$element->user_email,
			'index.php?option=com_hikashop&ctrl=user&task=edit&user_id='.$element->user_id,
		);
	}
	public function onAfterUserUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'user',
			'update',
			$element->user_id,
			$element->user_email,
			'index.php?option=com_hikashop&ctrl=user&task=edit&user_id='.$element->user_id,
		);
	}	
	public function onBeforeUserDelete(&$elements, &$do) {
		$userClass = hikashop_get('class.user');
		if(!isset($this->data['user']))
			$this->data['user'] = array();
		if(!isset($this->data['user']['delete']))
			$this->data['user']['delete'] = array();
		foreach($elements as $element) {
			$this->data['user']['delete'][$element] = $userClass->get($element);
		}
	}
	public function onAfterUserDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'user with id '.$element;
			if(!empty($this->data['user']['delete'][$element]) && !empty($this->data['user']['delete'][$element]->user_email)) {
				$name = $this->data['user']['delete'][$element]->user_email;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'user',
				'delete',
				0,
				$name,
			);
		}
	}
	public function onAfterDiscountCreate(&$element) {
		$type = 'discount';
		if(!empty($element->discount_type))
			$type = $element->discount_type;
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			$type,
			'add',
			$element->discount_id,
			$element->discount_code,
			'index.php?option=com_hikashop&ctrl=discount&task=edit&discount_id='.$element->discount_id,
		);
	}
	public function onAfteDiscountUpdate(&$element) {
		$type = 'discount';
		if(!empty($element->discount_type))
			$type = $element->discount_type;
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			$type,
			'update',
			$element->discount_id,
			$element->discount_code,
			'index.php?option=com_hikashop&ctrl=discount&task=edit&discount_id='.$element->discount_id,
		);
	}
	public function onBeforeDiscountDelete(&$elements, &$do) {
		$discountClass = hikashop_get('class.discount');
		if(!isset($this->data['discount']))
			$this->data['discount'] = array();
		if(!isset($this->data['discount']['delete']))
			$this->data['discount']['delete'] = array();
		foreach($elements as $element) {
			$this->data['discount']['delete'][$element] = $discountClass->get($element);
		}
	}
	public function onAfterDiscountDelete(&$elements) {
		foreach($elements as $element) {
			$type = 'discount';
			if(!empty($this->data['discount']['delete'][$element]) && !empty($this->data['discount']['delete'][$element]->discount_type)) {
				$type = $this->data['discount']['delete'][$element]->discount_type;
			}
			$name = 'discount with id '.$element;
			if(!empty($this->data['discount']['delete'][$element]) && !empty($this->data['discount']['delete'][$element]->discount_code)) {
				$name = $this->data['discount']['delete'][$element]->discount_code;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				$type,
				'delete',
				0,
				$name,
			);
		}
	}
	public function onAfterFieldCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'field',
			'add',
			$element->field_id,
			$element->field_realname,
			'index.php?option=com_hikashop&ctrl=field&task=edit&field_id='.$element->field_id,
		);
	}
	public function onAfterFieldUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'field',
			'update',
			$element->field_id,
			$element->field_realname,
			'index.php?option=com_hikashop&ctrl=field&task=edit&field_id='.$element->field_id,
		);
	}
	public function onBeforeFieldDelete(&$elements, &$do) {
		$fieldClass = hikashop_get('class.field');
		if(!isset($this->data['field']))
			$this->data['field'] = array();
		if(!isset($this->data['field']['delete']))
			$this->data['field']['delete'] = array();
		foreach($elements as $element) {
			$this->data['field']['delete'][$element] = $fieldClass->get($element);
		}
	}
	public function onAfterFieldDelete(&$elements, $keepdata) {
		foreach($elements as $element) {
			$name = 'field with id '.$element;
			if(!empty($this->data['field']['delete'][$element]) && !empty($this->data['field']['delete'][$element]->field_realname)) {
				$name = $this->data['field']['delete'][$element]->field_realname;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'field',
				'delete',
				0,
				$name,
			);
		}
	}
	public function onAfterTaxationCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'taxation',
			'add',
			$element->taxation_id,
			$element->taxation_id,
			'index.php?option=com_hikashop&ctrl=taxation&task=edit&taxation_id='.$element->taxation_id,
		);
	}
	public function onAfterTaxationUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'taxation',
			'update',
			$element->taxation_id,
			$element->taxation_id,
			'index.php?option=com_hikashop&ctrl=taxation&task=edit&taxation_id='.$element->taxation_id,
		);
	}
	public function onAfterTaxationDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'tax rule with id '.$element;
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'taxation',
				'delete',
				0,
				$name,
			);
		}
	}
	public function onAfterTaxCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'tax',
			'add',
			$element->tax_namekey,
			$element->tax_namekey,
			'index.php?option=com_hikashop&ctrl=tax&task=edit&tax_namekey='.$element->tax_namekey,
		);
	}
	public function onAfterTaxUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'tax',
			'update',
			$element->tax_namekey,
			$element->tax_namekey,
			'index.php?option=com_hikashop&ctrl=tax&task=edit&tax_namekey='.$element->tax_namekey,
		);
	}
	public function onBeforeTaxDelete(&$elements, &$do) {
		$taxClass = hikashop_get('class.tax');
		if(!isset($this->data['tax']))
			$this->data['tax'] = array();
		if(!isset($this->data['tax']['delete']))
			$this->data['tax']['delete'] = array();
		foreach($elements as $element) {
			$this->data['tax']['delete'][$element] = $taxClass->get($element);
		}
	}
	public function onAfterTaxDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'tax with id '.$element;
			if(!empty($this->data['tax']['delete'][$element]) && !empty($this->data['tax']['delete'][$element]->tax_namekey)) {
				$name = $this->data['tax']['delete'][$element]->tax_namekey;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'tax',
				'delete',
				0,
				$name,
			);
		}
	}

	public function onAfterCurrencyCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'currency',
			'add',
			$element->currency_id,
			$element->currency_code,
			'index.php?option=com_hikashop&ctrl=currency&task=edit&currency_id='.$element->currency_id,
		);
	}
	public function onAfterCurrencyUpdate(&$element) {
		if(empty($element->currency_code)) {
			$code = $element->old->currency_code;
		} else {
			$code = $element->currency_code;
		}
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'currency',
			'update',
			$element->currency_id,
			$code,
			'index.php?option=com_hikashop&ctrl=currency&task=edit&currency_id='.$element->currency_id,
		);
	}
	public function onBeforeCurrencyDelete(&$elements, &$do) {
		$currencyClass = hikashop_get('class.currency');
		if(!isset($this->data['currency']))
			$this->data['currency'] = array();
		if(!isset($this->data['currency']['delete']))
			$this->data['currency']['delete'] = array();
		foreach($elements as $element) {
			$this->data['currency']['delete'][$element] = $currencyClass->get($element);
		}
	}
	public function onAfterCurrencyDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'currency with id '.$element;
			if(!empty($this->data['currency']['delete'][$element]) && !empty($this->data['currency']['delete'][$element]->currency_code)) {
				$name = $this->data['currency']['delete'][$element]->currency_code;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'currency',
				'delete',
				0,
				$name,
			);
		}
	}
	public function onAfterZoneCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'zone',
			'add',
			$element->zone_id,
			$element->zone_name,
			'index.php?option=com_hikashop&ctrl=zone&task=edit&zone_id='.$element->zone_id,
		);
	}
	public function onAfterZoneUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'zone',
			'update',
			$element->zone_id,
			$element->zone_name,
			'index.php?option=com_hikashop&ctrl=zone&task=edit&zone_id='.$element->zone_id,
		);
	}
	public function onBeforeZoneDelete(&$elements, &$do) {
		$zoneClass = hikashop_get('class.zone');
		if(!isset($this->data['zone']))
			$this->data['zone'] = array();
		if(!isset($this->data['zone']['delete']))
			$this->data['zone']['delete'] = array();
		foreach($elements as $element) {
			$this->data['zone']['delete'][$element] = $zoneClass->get($element);
		}
	}
	public function onAfterZoneDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'zone with id '.$element;
			if(!empty($this->data['zone']['delete'][$element]) && !empty($this->data['zone']['delete'][$element]->zone_name)) {
				$name = $this->data['zone']['delete'][$element]->zone_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'zone',
				'delete',
				0,
				$name,
			);
		}
	}
	public function onAfterWarehouseCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'warehouse',
			'add',
			$element->warehouse_id,
			$element->warehouse_name,
			'index.php?option=com_hikashop&ctrl=warehouse&task=edit&warehouse_id='.$element->warehouse_id,
		);
	}
	public function onAfterWarehouseUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'warehouse',
			'update',
			$element->warehouse_id,
			$element->warehouse_name,
			'index.php?option=com_hikashop&ctrl=warehouse&task=edit&warehouse_id='.$element->warehouse_id,
		);
	}
	public function onBeforeWarehouseDelete(&$elements, &$do) {
		$warehouseClass = hikashop_get('class.warehouse');
		if(!isset($this->data['warehouse']))
			$this->data['warehouse'] = array();
		if(!isset($this->data['warehouse']['delete']))
			$this->data['warehouse']['delete'] = array();
		foreach($elements as $element) {
			$this->data['warehouse']['delete'][$element] = $warehouseClass->get($element);
		}
	}
	public function onAfterWarehouseDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'warehouse with id '.$element;
			if(!empty($this->data['warehouse']['delete'][$element]) && !empty($this->data['warehouse']['delete'][$element]->warehouse_name)) {
				$name = $this->data['warehouse']['delete'][$element]->warehouse_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'warehouse',
				'delete',
				0,
				$name,
			);
		}
	}
	public function onAfterMassactionCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'massaction',
			'add',
			$element->massaction_id,
			$element->massaction_name,
			'index.php?option=com_hikashop&ctrl=massaction&task=edit&massaction_id='.$element->massaction_id,
		);
	}

	public function onAfterMassactionUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'massaction',
			'update',
			$element->massaction_id,
			$element->massaction_name,
			'index.php?option=com_hikashop&ctrl=massaction&task=edit&massaction_id='.$element->massaction_id,
		);
	}
	public function onBeforeMassactionDelete(&$elements, &$do) {
		$massactionClass = hikashop_get('class.massaction');
		if(!isset($this->data['massaction']))
			$this->data['massaction'] = array();
		if(!isset($this->data['massaction']['delete']))
			$this->data['massaction']['delete'] = array();
		foreach($elements as $element) {
			$this->data['massaction']['delete'][$element] = $massactionClass->get($element);
		}
	}
	public function onAfterMassactionDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'massaction with id '.$element;
			if(!empty($this->data['massaction']['delete'][$element]) && !empty($this->data['massaction']['delete'][$element]->massaction_name)) {
				$name = $this->data['massaction']['delete'][$element]->massaction_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'massaction',
				'delete',
				0,
				$name,
			);
		}
	}

	public function onAfterMassactionProcess(&$massaction, &$report) {
		if(!empty($massaction->massaction_id)) {
			$this->addHikashopLog(
				'PLG_ACTIONLOG_HIKASHOP_MASSACTION_PROCESSED',
				'massaction',
				'process',
				$massaction->massaction_id,
				$massaction->massaction_name,
				'index.php?option=com_hikashop&ctrl=massaction&task=edit&massaction_id='.$massaction->massaction_id,
			);
		}
	}

	public function onAfterCharacteristicCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'characteristic',
			'add',
			$element->characteristic_id,
			$element->characteristic_value,
			'index.php?option=com_hikashop&ctrl=characteristic&task=edit&characteristic_id='.$element->characteristic_id,
		);
	}

	public function onAfterCharacteristicUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'characteristic',
			'update',
			$element->characteristic_id,
			$element->characteristic_value,
			'index.php?option=com_hikashop&ctrl=characteristic&task=edit&characteristic_id='.$element->characteristic_id,
		);
	}
	public function onBeforeCharacteristicDelete(&$elements, &$do) {
		$characteristicClass = hikashop_get('class.characteristic');
		if(!isset($this->data['characteristic']))
			$this->data['characteristic'] = array();
		if(!isset($this->data['characteristic']['delete']))
			$this->data['characteristic']['delete'] = array();
		foreach($elements as $element) {
			$this->data['characteristic']['delete'][$element] = $characteristicClass->get($element);
		}
	}
	public function onAfterCharacteristicDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'characteristic with id '.$element;
			if(!empty($this->data['characteristic']['delete'][$element]) && !empty($this->data['characteristic']['delete'][$element]->characteristic_name)) {
				$name = $this->data['characteristic']['delete'][$element]->characteristic_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'characteristic',
				'delete',
				0,
				$name,
			);
		}
	}

	public function onAfterViewUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'view',
			'update',
			$element->id,
			$element->view.' / '.$element->file,
			'index.php?option=com_hikashop&ctrl=view&task=edit&id='.$element->id,
		);
	}
	public function onAfterViewDelete(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
			'view',
			'update',
			$element->id,
			$element->view.' / '.$element->file,
			'index.php?option=com_hikashop&ctrl=view&task=edit&id='.$element->id,
		);
	}

	public function onAfterFilterCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'filter',
			'add',
			$element->filter_id,
			$element->filter_name,
			'index.php?option=com_hikashop&ctrl=filter&task=edit&filter_id='.$element->filter_id,
		);
	}

	public function onAfterFilterUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'filter',
			'update',
			$element->filter_id,
			$element->filter_name,
			'index.php?option=com_hikashop&ctrl=filter&task=edit&filter_id='.$element->filter_id,
		);
	}
	public function onBeforeFilterDelete(&$elements, &$do) {
		$filterClass = hikashop_get('class.filter');
		if(!isset($this->data['filter']))
			$this->data['filter'] = array();
		if(!isset($this->data['filter']['delete']))
			$this->data['filter']['delete'] = array();
		foreach($elements as $element) {
			$this->data['filter']['delete'][$element] = $filterClass->get($element);
		}
	}
	public function onAfterFilterDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'filter with id '.$element;
			if(!empty($this->data['filter']['delete'][$element]) && !empty($this->data['filter']['delete'][$element]->filter_name)) {
				$name = $this->data['filter']['delete'][$element]->filter_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'filter',
				'delete',
				0,
				$name,
			);
		}
	}

	public function onAfterBannerCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'banner',
			'add',
			$element->banner_id,
			$element->banner_title,
			'index.php?option=com_hikashop&ctrl=banner&task=edit&banner_id='.$element->banner_id,
		);
	}

	public function onAfterBannerUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'banner',
			'update',
			$element->banner_id,
			$element->banner_title,
			'index.php?option=com_hikashop&ctrl=banner&task=edit&banner_id='.$element->banner_id,
		);
	}
	public function onBeforeBannerDelete(&$elements, &$do) {
		$bannerClass = hikashop_get('class.banner');
		if(!isset($this->data['banner']))
			$this->data['banner'] = array();
		if(!isset($this->data['banner']['delete']))
			$this->data['banner']['delete'] = array();
		foreach($elements as $element) {
			$this->data['banner']['delete'][$element] = $bannerClass->get($element);
		}
	}
	public function onAfterBannerDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'banner with id '.$element;
			if(!empty($this->data['banner']['delete'][$element]) && !empty($this->data['banner']['delete'][$element]->banner_title)) {
				$name = $this->data['banner']['delete'][$element]->banner_title;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'banner',
				'delete',
				0,
				$name,
			);
		}
	}

	public function onAfterBadgeCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'badge',
			'add',
			$element->badge_id,
			$element->badge_name,
			'index.php?option=com_hikashop&ctrl=badge&task=edit&badge_id='.$element->badge_id,
		);
	}

	public function onAfterBadgeUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'badge',
			'update',
			$element->badge_id,
			$element->badge_name,
			'index.php?option=com_hikashop&ctrl=badge&task=edit&badge_id='.$element->badge_id,
		);
	}
	public function onBeforeBadgeDelete(&$elements, &$do) {
		$badgeClass = hikashop_get('class.badge');
		if(!isset($this->data['badge']))
			$this->data['badge'] = array();
		if(!isset($this->data['badge']['delete']))
			$this->data['badge']['delete'] = array();
		foreach($elements as $element) {
			$this->data['badge']['delete'][$element] = $badgeClass->get($element);
		}
	}
	public function onAfterBadgeDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'badge with id '.$element;
			if(!empty($this->data['badge']['delete'][$element]) && !empty($this->data['badge']['delete'][$element]->badge_name)) {
				$name = $this->data['badge']['delete'][$element]->badge_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'badge',
				'delete',
				0,
				$name,
			);
		}
	}

	public function onAfterLimitCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'limit',
			'add',
			$element->limit_id,
			$element->limit_id,
			'index.php?option=com_hikashop&ctrl=badge&task=edit&limit_id='.$element->limit_id,
		);
	}

	public function onAfterLimitUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'limit',
			'update',
			$element->limit_id,
			$element->limit_id,
			'index.php?option=com_hikashop&ctrl=badge&task=edit&limit_id='.$element->limit_id,
		);
	}
	public function onAfterLimitDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'limit with id '.$element;
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'limit',
				'delete',
				0,
				$name,
			);
		}
	}

	public function onAfterHikaPluginCreate($type, &$element) {
		$id = $type.'_id';
		$name = $type.'_name';
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			$type,
			'add',
			$element->$id,
			$element->$name,
			'index.php?option=com_hikashop&ctrl=plugin&plugin_type='.$type.'&name='.$element->payment_type.'&task=edit&subtask='.$type.'_edit&'.$id.'='.$element->$id,
		);
	}
	public function onAfterHikaPluginUpdate($type, &$element) {
		$id = $type.'_id';
		$name = $type.'_name';
		$type_name = $type.'_type';
		if(empty($element->$name))
			$payment_name = @$element->old->$name;
		else
			$payment_name = $element->$name;
		if(empty($element->$type_name))
			$payment_type = @$element->old->$type_name;
		else
			$payment_type = $element->$type_name;
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			$type,
			'update',
			$element->$id,
			$payment_name,
			'index.php?option=com_hikashop&ctrl=plugin&plugin_type='.$type.'&name='.$payment_type.'&task=edit&subtask='.$type.'_edit&'.$id.'='.$element->$id,
		);
	}
	public function onBeforePluginDelete($type, &$elements, &$do) {
		$pluginClass = hikashop_get('class.plugin');
		if(!isset($this->data['plugin']))
			$this->data['plugin'] = array();
		if(!isset($this->data['plugin']['delete']))
			$this->data['plugin']['delete'] = array();
		foreach($elements as $element) {
			$this->data['plugin']['delete'][$element] = $pluginClass->get($element);
		}
	}
	public function onAfterHikaPluginDelete($type, &$elements) {
		foreach($elements as $element) {
			$plugin_name = $type.'_name';
			$name = $type.' plugin with id '.$element;
			if(!empty($this->data['plugin']['delete'][$element]) && !empty($this->data['plugin']['delete'][$element]->$plugin_name)) {
				$name = $this->data['plugin']['delete'][$element]->$plugin_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				$type,
				'delete',
				0,
				$name,
			);
		}
	}

	public function onBeforeCartSave(&$element, &$do) {
		if(!isset($this->data['cart']))
			$this->data['cart'] = array();
		$this->data['cart']['new'] = empty($element->cart_id);
	}
	public function onAfterCartSave(&$element) {
		$action = 'add';
		$message = 'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED';
		if(empty($this->data['cart']['new'])) {
			$action = 'update';
			$message = 'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED';
		}
		$type = 'cart';
		if(!empty($element->cart_type)) {
			$type = $element->cart_type;
		}elseif(!empty($element->old->cart_type)) {
			$type = $element->old->cart_type;
		}
		$this->addHikashopLog(
			$message,
			$type,
			$action,
			$element->cart_id,
			$element->cart_id,
			'index.php?option=com_hikashop&ctrl=cart&task=edit&cid='.$element->cart_id,
		);
	}


	public function onBeforeCartDelete(&$elements, &$do) {
		$cartClass = hikashop_get('class.cart');
		if(!isset($this->data['cart']))
			$this->data['cart'] = array();
		if(!isset($this->data['cart']['delete']))
			$this->data['cart']['delete'] = array();
		foreach($elements as $element) {
			$this->data['cart']['delete'][$element] = $cartClass->get($element);
		}
	}
	public function onAfterCartDelete(&$elements) {
		foreach($elements as $element) {
			$type = 'cart';
			if(!empty($this->data['cart']['delete'][$element]) && !empty($this->data['cart']['delete'][$element]->cart_type)) {
				$type = $this->data['cart']['delete'][$element]->cart_type;
			}
			$name = 'cart with id '.$element;
			if(!empty($this->data['cart']['delete'][$element]) && !empty($this->data['cart']['delete'][$element]->cart_name)) {
				$name = $this->data['cart']['delete'][$element]->cart_name;
			}
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				$type,
				'delete',
				0,
				$name
			);
		}
	}

	public function onAfterConfigSave(&$params) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'config',
			'update',
			0,
			'HIKASHOP_CONFIGURATION',
			'index.php?option=com_hikashop&ctrl=config',
		);
	}

	public function onAfterEmail_logCreate(&$email_log) {
		if(empty($email_log->email_log_id))
			return;
		$this->addHikashopLog(
			'PLG_ACTIONLOG_HIKASHOP_MAIL_SENT',
			'email',
			'send',
			$email_log->email_log_id,
			hikashop_translate($email_log->email_log_name),
			'index.php?option=com_hikashop&ctrl=email_history&task=edit&email_log_id='.$email_log->email_log_id,
			$email_log->email_log_recipient_email,
			'',
			$email_log->email_log_sender_email,
		);
	}


	public function onAfterVoteCreate(&$element, &$return_datat) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'vote',
			'add',
			$element->vote_id,
			$element->vote_id,
			'index.php?option=com_hikashop&ctrl=vote&task=edit&vote_id='.$element->vote_id,
		);
	}

	public function onAfterVoteUpdate(&$element, &$return_data) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'vote',
			'update',
			$element->vote_id,
			$element->vote_id,
			'index.php?option=com_hikashop&ctrl=vote&task=edit&vote_id='.$element->vote_id,
		);
	}
	public function onAfterVoteDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'vote with id '.$element;
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'vote',
				'delete',
				0,
				$name
			);
		}
	}
	public function onAfterWaitlistCreate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_ADDED',
			'waitlist',
			'add',
			$element->waitlist_id,
			$element->waitlist_id,
			'index.php?option=com_hikashop&ctrl=waitlist&task=edit&waitlist_id='.$element->waitlist_id,
		);
	}

	public function onAfterWaitlistUpdate(&$element) {
		$this->addHikashopLog(
			'PLG_SYSTEM_ACTIONLOGS_CONTENT_UPDATED',
			'waitlist',
			'update',
			$element->waitlist_id,
			$element->waitlist_id,
			'index.php?option=com_hikashop&ctrl=waitlist&task=edit&waitlist_id='.$element->waitlist_id,
		);
	}
	public function onAfterWaitlistDelete(&$elements) {
		foreach($elements as $element) {
			$name = 'waitlist with id '.$element;
			$this->addHikashopLog(
				'PLG_SYSTEM_ACTIONLOGS_CONTENT_DELETED',
				'waitlist',
				'delete',
				0,
				$name
			);
		}
	}
	private function addHikashopLog($messageLanguageKey, $type, $action, $id=0, $name='', $url='', $username='', $user_link='', $sender='') {
		$types = $this->params->get('types');
		if(is_null($types) || !in_array($type, $types))
			return;

		$typeKey = 'HIKASHOP_TYPE_'.strtoupper($type);
		$message = array(
			'action'   => $action,
			'type'     => $typeKey,
			'id'       => $id,
		);

		$user = JFactory::getUser();
		if ($user->guest) {
			$hkuser = hikashop_loadUser(true);
			if(!empty($hkuser->user_email)) {
				$message['username'] = $hkuser->user_email;
				$message['accountlink'] = 'index.php?option=com_hikashop&ctrl=user&task=edit&user_id=' . $hkuser->user_id;
			}else {
				$ip = hikashop_getIP();
				if($ip) {
					$message['username'] = hikashop_getIP();
				}
			}
		}

		if(!empty($id)) {
			$message['id'] = $id;
		}
		if(!empty($name)) {
			$message['title'] = $name;
		}
		if(!empty($url)) {
			$message['itemlink'] = $url;
		}
		if(!empty($username)) {
			$message['username'] = $username;
		}
		if(!empty($user_link)) {
			$message['accountlink'] = $user_link;
		}
		if(!empty($sender)) {
			$message['sender'] = $sender;
		}
		$this->addLog(array($message), $messageLanguageKey, 'com_hikashop');
	}
}
